## libqtshadowsocks 2.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(QtShadowsocks
        VERSION 2.1.0
        LANGUAGES CXX)

option(BUILD_SHARED_LIBS "Build ${PROJECT_NAME} as a shared library" ON)

set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib
    CACHE PATH "Installation directory for libraries")
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include
    CACHE PATH "Installation directory for headers")
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

find_package(Qt5Core 5.5)
find_package(Qt5Network 5.5)
find_package(PkgConfig)

pkg_search_module(BOTAN REQUIRED botan-2>=2.3.0 botan-1.10)
if(BOTAN_VERSION VERSION_GREATER 2.0)
    message(STATUS "Botan-2 is found and will be used in this build")
    add_definitions(-DUSE_BOTAN2)
else()
    message(DEPRECATION "Botan-1.10 is found and will be used in this build. However, Botan-1.10 is deprecated and should not be used if possible")
endif()
find_library(BOTAN_LIBRARY_VAR
             NAMES ${BOTAN_LIBRARIES}
             HINTS ${BOTAN_LIBRARY_DIRS} ${BOTAN_LIBDIR})

if(BUILD_SHARED_LIBS)
    add_definitions(-DQSS_LIBRARY)
else()
    add_definitions(-DQSS_STATIC)
    if (MINGW)
        # This however doesn't fix the problem that the executables are depending on the GCC shared libraries
        # I can't find a solution in CMake so far. The workaround is to manually append "-l:libgcc.a -l:libstdc++.a -l:libwinpthread.a" to the end of executables' linklibs.rsp files (in CMakeFiles directory)
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libgcc -static-libstdc++")
    endif()
endif()

if(WIN32 OR APPLE)
    add_definitions(-DFD_SETSIZE=1024)
endif()

add_subdirectory(lib)
add_subdirectory(shadowsocks-libqss)
find_package(Qt5Test)
if (Qt5Test_FOUND)
    # enable_testing() has to be in the root CMakeLists.txt, see https://cmake.org/pipermail/cmake/2010-November/040725.html
    enable_testing()
    add_subdirectory(test)
endif()

=== lib/CMakeLists.txt ===
set(LIBNAME "QtShadowsocks")
add_definitions(-DQSS_VERSION="${PROJECT_VERSION}")

set(SOURCE
    QtShadowsocks)

set(HEADERS
    QtShadowsocks)

include(crypto/CMakeLists.txt)
include(network/CMakeLists.txt)
include(types/CMakeLists.txt)
include(util/CMakeLists.txt)

add_library(${LIBNAME} ${SOURCE})

target_include_directories(${LIBNAME} PRIVATE ${BOTAN_INCLUDE_DIRS})

set_target_properties(${LIBNAME} PROPERTIES VERSION ${PROJECT_VERSION}
                                            SOVERSION ${PROJECT_VERSION_MAJOR})
target_link_libraries(${LIBNAME}
    PUBLIC Qt5::Core
    PUBLIC Qt5::Network
    PRIVATE ${BOTAN_LIBRARY_VAR})

foreach(LIB Qt5Network Qt5Core ${BOTAN_LIBRARIES})
    set(PRIVATE_LIBS "${PRIVATE_LIBS} -l${LIB}")
endforeach()
configure_file(QtShadowsocks.pc.in ${CMAKE_CURRENT_BINARY_DIR}/QtShadowsocks.pc
    @ONLY
    NEWLINE_STYLE UNIX)

install(TARGETS ${LIBNAME}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR})
install(FILES ${HEADERS}
    DESTINATION ${INCLUDE_INSTALL_DIR}/${PROJECT_NAME})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/QtShadowsocks.pc
    DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

=== shadowsocks-libqss/CMakeLists.txt ===
set(TASK "shadowsocks-libqss")

set(SOURCE
    client.cpp
    main.cpp
    utils.cpp
    )

add_executable(${TASK} ${SOURCE})

target_link_libraries(${TASK} Qt5::Core Qt5::Network QtShadowsocks)
target_include_directories(${TASK}
    PUBLIC ${PROJECT_SOURCE_DIR}/lib)

install(TARGETS ${TASK} RUNTIME DESTINATION bin)

=== test/CMakeLists.txt ===
macro(qss_add_test component)
    add_executable(${component} ${component}.cpp)
    add_test(${component} ${component})
    target_link_libraries(${component}
                          Qt5::Core
                          Qt5::Network
                          Qt5::Test
                          QtShadowsocks)
    target_include_directories(${component}
                               PUBLIC ${PROJECT_SOURCE_DIR}/lib)
endmacro(qss_add_test)

qss_add_test(address)
qss_add_test(chacha)
qss_add_test(cipher)
qss_add_test(encryptor)
qss_add_test(profile)

=== lib/crypto/CMakeLists.txt ===
list(APPEND SOURCE
    ${CMAKE_CURRENT_LIST_DIR}/chacha.cpp
    ${CMAKE_CURRENT_LIST_DIR}/cipher.cpp
    ${CMAKE_CURRENT_LIST_DIR}/encryptor.cpp
    ${CMAKE_CURRENT_LIST_DIR}/rc4.cpp
    )

set(CRYPTO_HEADERS
    ${CMAKE_CURRENT_LIST_DIR}/chacha.h
    ${CMAKE_CURRENT_LIST_DIR}/cipher.h
    ${CMAKE_CURRENT_LIST_DIR}/encryptor.h
    ${CMAKE_CURRENT_LIST_DIR}/rc4.h
    )

install(FILES ${CRYPTO_HEADERS}
    DESTINATION ${INCLUDE_INSTALL_DIR}/${PROJECT_NAME}/crypto)

=== lib/network/CMakeLists.txt ===
list(APPEND SOURCE
    ${CMAKE_CURRENT_LIST_DIR}/httpproxy.cpp
    ${CMAKE_CURRENT_LIST_DIR}/socketstream.cpp
    ${CMAKE_CURRENT_LIST_DIR}/tcprelay.cpp
    ${CMAKE_CURRENT_LIST_DIR}/tcprelayclient.cpp
    ${CMAKE_CURRENT_LIST_DIR}/tcprelayserver.cpp
    ${CMAKE_CURRENT_LIST_DIR}/tcpserver.cpp
    ${CMAKE_CURRENT_LIST_DIR}/udprelay.cpp
    )

set(NETWORK_HEADERS
    ${CMAKE_CURRENT_LIST_DIR}/httpproxy.h
    ${CMAKE_CURRENT_LIST_DIR}/socketstream.h
    ${CMAKE_CURRENT_LIST_DIR}/tcprelay.h
    ${CMAKE_CURRENT_LIST_DIR}/tcprelayclient.h
    ${CMAKE_CURRENT_LIST_DIR}/tcprelayserver.h
    ${CMAKE_CURRENT_LIST_DIR}/tcpserver.h
    ${CMAKE_CURRENT_LIST_DIR}/udprelay.h
    )

install(FILES ${NETWORK_HEADERS}
    DESTINATION ${INCLUDE_INSTALL_DIR}/${PROJECT_NAME}/network)

=== lib/types/CMakeLists.txt ===
list(APPEND SOURCE
    ${CMAKE_CURRENT_LIST_DIR}/address.cpp
    ${CMAKE_CURRENT_LIST_DIR}/profile.cpp
    )

set(TYPES_HEADERS
    ${CMAKE_CURRENT_LIST_DIR}/address.h
    ${CMAKE_CURRENT_LIST_DIR}/profile.h
    )

install(FILES ${TYPES_HEADERS}
    DESTINATION ${INCLUDE_INSTALL_DIR}/${PROJECT_NAME}/types)

=== lib/util/CMakeLists.txt ===
list(APPEND SOURCE
    ${CMAKE_CURRENT_LIST_DIR}/addresstester.cpp
    ${CMAKE_CURRENT_LIST_DIR}/common.cpp
    ${CMAKE_CURRENT_LIST_DIR}/controller.cpp
    )

set(UTIL_HEADERS
    ${CMAKE_CURRENT_LIST_DIR}/addresstester.h
    ${CMAKE_CURRENT_LIST_DIR}/common.h
    ${CMAKE_CURRENT_LIST_DIR}/controller.h
    ${CMAKE_CURRENT_LIST_DIR}/export.h
    )

install(FILES ${UTIL_HEADERS}
    DESTINATION ${INCLUDE_INSTALL_DIR}/${PROJECT_NAME}/util)

=== debian/changelog ===
libqtshadowsocks (2.1.0-2+rb2) UNRELEASED; urgency=medium

  * update

 -- Boyuan Yang <byang@debian.org>  Fri, 22 Jan 2021 11:50:17 +0800

libqtshadowsocks (2.1.0-2) unstable; urgency=medium

  * Rebuild against new Qt 5.11.1.
  * Rebuild for pure source-only upload.

 -- Boyuan Yang <byang@debian.org>  Fri, 14 Sep 2018 09:48:38 -0400

libqtshadowsocks (2.1.0-1) unstable; urgency=medium

  * Initial release. Closes: #887734

 -- Boyuan Yang <byang@debian.org>  Thu, 06 Sep 2018 15:13:48 -0400

=== debian/control ===
Source: libqtshadowsocks
Section: libs
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Uploaders:
 Debian Bridges Team <team+bridges@tracker.debian.org>,
 Roger Shimizu <rosh@debian.org>,
Build-Depends:
 cmake (>= 3.1.0),
 debhelper (>= 11),
 dh-exec,
 libbotan-2-dev,
 pkg-config,
 qt5-qmake,
 qtbase5-dev,
Standards-Version: 4.2.1
Homepage: https://github.com/shadowsocks/libQtShadowsocks
Vcs-Git: https://salsa.debian.org/bridges-team/libqtshadowsocks.git
Vcs-Browser: https://salsa.debian.org/bridges-team/libqtshadowsocks

Package: libqtshadowsocks-dev
Section: libdevel
Architecture: any
Depends:
 libqtshadowsocks2 (= ${binary:Version}),
 ${misc:Depends},
Description: Development files of libQtShadowsocks
 libQtShadowsocks provides a lightweight and fast implementation of
 shadowsocks protocol. This library is written in C++ using Qt.
 .
 This package provides the development files.

Package: libqtshadowsocks2
Multi-Arch: same
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Lightweight and ultra-fast shadowsocks library written in C++/Qt
 libQtShadowsocks provides a lightweight and fast implementation of
 shadowsocks protocol. This library is written in C++ using Qt.
 .
 This package provides the library files.

Package: shadowsocks-libqtshadowsocks
Section: net
Architecture: any
Depends:
 libqtshadowsocks2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Another CLI shadowsocks client using libQtShadowsocks
 libQtShadowsocks provides a lightweight and fast implementation of
 shadowsocks protocol. This library is written in C++ using Qt.
 .
 This package provides a simple cli shadowsocks client.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export QT_SELECT := 5

include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing
